import es, threading, urllib2, string, os, string

info = es.AddonInfo() 
info.name     = "AutoUpdate" 
info.version  = "1.1" 
info.url      = "http://addons.eventscripts.com/addons/view/autoupdate" 
info.basename = "autoupdate" 
info.author   = "JoeyT2007"

__au_version = es.ServerVar("__au_version", 1.1, "The version of AutoUpdate you are running.")
__au_version.makepublic()

class CheckUpdates(threading.Thread):
    def __init__(self, info):
        self.__au_script_name = info["name"]
        self.__au_script_realname = info["basename"]
        self.__au_script_version = info["version"]
        if info["updateurl"]:
            self.__au_update_url = info["updateurl"]
        else:
            self.__au_update_url = "http://addons.eventscripts.com/addons/download/" + info["basename"]
        threading.Thread.__init__(self)

    def run(self):
        es.msg("#multi", "#green[%s]#default Checking for updates..." % self.__au_script_name)
        __au_online_version = None
        __au_online_version = urllib2.urlopen("http://addons.eventscripts.com/addons/chklatestver/%s" % self.__au_script_realname).read()
        if __au_online_version != None:
            if self.__au_script_version != __au_online_version:
                es.msg("#multi", "#green[%s]#default This server is running an old version of %s, auto-updating..." % (self.__au_script_name, self.__au_script_name))
                __au_update_file = None
                __au_update_file = urllib2.urlopen(self.__au_update_url).read()
                if __au_update_file != None:
                    __au_script_path = es.getAddonPath(self.__au_script_realname) + "/" + self.__au_script_realname + ".py"
                    if os.path.exists(__au_script_path):
                        __au_script_file = open(__au_script_path, 'w')
                        __au_script_file.write(__au_update_file)
                        __au_script_file.close()
                        es.reload("%s" % self.__au_script_realname)
                        es.msg("#multi", "#green[%s]#default Auto-update complete!" % self.__au_script_name)
                    else:
                        es.msg("#multi", "#green[%s]#default Cannot install updates!" % self.__au_script_name)
                else:
                    es.msg("#multi", "#green[%s]#default Cannot check for updates!" % self.__au_script_name)
            else:
                es.msg("#multi", "#green[%s]#default No new updates found!" % self.__au_script_name)
        else:
            es.msg("#multi", "#green[%s]#default Cannot check for updates!" % self.__au_script_name)